t / test-lib-functions.shon commit Merge branch 'jc/make-dedup-ls-files-output' (a505f62)
   1# Library of functions shared by all tests scripts, included by
   2# test-lib.sh.
   3#
   4# Copyright (c) 2005 Junio C Hamano
   5#
   6# This program is free software: you can redistribute it and/or modify
   7# it under the terms of the GNU General Public License as published by
   8# the Free Software Foundation, either version 2 of the License, or
   9# (at your option) any later version.
  10#
  11# This program is distributed in the hope that it will be useful,
  12# but WITHOUT ANY WARRANTY; without even the implied warranty of
  13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  14# GNU General Public License for more details.
  15#
  16# You should have received a copy of the GNU General Public License
  17# along with this program.  If not, see http://www.gnu.org/licenses/ .
  18
  19# The semantics of the editor variables are that of invoking
  20# sh -c "$EDITOR \"$@\"" files ...
  21#
  22# If our trash directory contains shell metacharacters, they will be
  23# interpreted if we just set $EDITOR directly, so do a little dance with
  24# environment variables to work around this.
  25#
  26# In particular, quoting isn't enough, as the path may contain the same quote
  27# that we're using.
  28test_set_editor () {
  29        FAKE_EDITOR="$1"
  30        export FAKE_EDITOR
  31        EDITOR='"$FAKE_EDITOR"'
  32        export EDITOR
  33}
  34
  35test_set_index_version () {
  36    GIT_INDEX_VERSION="$1"
  37    export GIT_INDEX_VERSION
  38}
  39
  40test_decode_color () {
  41        awk '
  42                function name(n) {
  43                        if (n == 0) return "RESET";
  44                        if (n == 1) return "BOLD";
  45                        if (n == 2) return "FAINT";
  46                        if (n == 3) return "ITALIC";
  47                        if (n == 7) return "REVERSE";
  48                        if (n == 30) return "BLACK";
  49                        if (n == 31) return "RED";
  50                        if (n == 32) return "GREEN";
  51                        if (n == 33) return "YELLOW";
  52                        if (n == 34) return "BLUE";
  53                        if (n == 35) return "MAGENTA";
  54                        if (n == 36) return "CYAN";
  55                        if (n == 37) return "WHITE";
  56                        if (n == 40) return "BLACK";
  57                        if (n == 41) return "BRED";
  58                        if (n == 42) return "BGREEN";
  59                        if (n == 43) return "BYELLOW";
  60                        if (n == 44) return "BBLUE";
  61                        if (n == 45) return "BMAGENTA";
  62                        if (n == 46) return "BCYAN";
  63                        if (n == 47) return "BWHITE";
  64                }
  65                {
  66                        while (match($0, /\033\[[0-9;]*m/) != 0) {
  67                                printf "%s<", substr($0, 1, RSTART-1);
  68                                codes = substr($0, RSTART+2, RLENGTH-3);
  69                                if (length(codes) == 0)
  70                                        printf "%s", name(0)
  71                                else {
  72                                        n = split(codes, ary, ";");
  73                                        sep = "";
  74                                        for (i = 1; i <= n; i++) {
  75                                                printf "%s%s", sep, name(ary[i]);
  76                                                sep = ";"
  77                                        }
  78                                }
  79                                printf ">";
  80                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
  81                        }
  82                        print
  83                }
  84        '
  85}
  86
  87lf_to_nul () {
  88        perl -pe 'y/\012/\000/'
  89}
  90
  91nul_to_q () {
  92        perl -pe 'y/\000/Q/'
  93}
  94
  95q_to_nul () {
  96        perl -pe 'y/Q/\000/'
  97}
  98
  99q_to_cr () {
 100        tr Q '\015'
 101}
 102
 103q_to_tab () {
 104        tr Q '\011'
 105}
 106
 107qz_to_tab_space () {
 108        tr QZ '\011\040'
 109}
 110
 111append_cr () {
 112        sed -e 's/$/Q/' | tr Q '\015'
 113}
 114
 115remove_cr () {
 116        tr '\015' Q | sed -e 's/Q$//'
 117}
 118
 119# Generate an output of $1 bytes of all zeroes (NULs, not ASCII zeroes).
 120# If $1 is 'infinity', output forever or until the receiving pipe stops reading,
 121# whichever comes first.
 122generate_zero_bytes () {
 123        test-tool genzeros "$@"
 124}
 125
 126# In some bourne shell implementations, the "unset" builtin returns
 127# nonzero status when a variable to be unset was not set in the first
 128# place.
 129#
 130# Use sane_unset when that should not be considered an error.
 131
 132sane_unset () {
 133        unset "$@"
 134        return 0
 135}
 136
 137test_tick () {
 138        if test -z "${test_tick+set}"
 139        then
 140                test_tick=1112911993
 141        else
 142                test_tick=$(($test_tick + 60))
 143        fi
 144        GIT_COMMITTER_DATE="$test_tick -0700"
 145        GIT_AUTHOR_DATE="$test_tick -0700"
 146        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 147}
 148
 149# Stop execution and start a shell. This is useful for debugging tests.
 150#
 151# Be sure to remove all invocations of this command before submitting.
 152
 153test_pause () {
 154        "$SHELL_PATH" <&6 >&5 2>&7
 155}
 156
 157# Wrap git with a debugger. Adding this to a command can make it easier
 158# to understand what is going on in a failing test.
 159#
 160# Examples:
 161#     debug git checkout master
 162#     debug --debugger=nemiver git $ARGS
 163#     debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
 164debug () {
 165        case "$1" in
 166        -d)
 167                GIT_DEBUGGER="$2" &&
 168                shift 2
 169                ;;
 170        --debugger=*)
 171                GIT_DEBUGGER="${1#*=}" &&
 172                shift 1
 173                ;;
 174        *)
 175                GIT_DEBUGGER=1
 176                ;;
 177        esac &&
 178        GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7
 179}
 180
 181# Call test_commit with the arguments
 182# [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
 183#
 184# This will commit a file with the given contents and the given commit
 185# message, and tag the resulting commit with the given tag name.
 186#
 187# <file>, <contents>, and <tag> all default to <message>.
 188#
 189# If the first argument is "-C", the second argument is used as a path for
 190# the git invocations.
 191
 192test_commit () {
 193        notick= &&
 194        signoff= &&
 195        indir= &&
 196        while test $# != 0
 197        do
 198                case "$1" in
 199                --notick)
 200                        notick=yes
 201                        ;;
 202                --signoff)
 203                        signoff="$1"
 204                        ;;
 205                -C)
 206                        indir="$2"
 207                        shift
 208                        ;;
 209                *)
 210                        break
 211                        ;;
 212                esac
 213                shift
 214        done &&
 215        indir=${indir:+"$indir"/} &&
 216        file=${2:-"$1.t"} &&
 217        echo "${3-$1}" > "$indir$file" &&
 218        git ${indir:+ -C "$indir"} add "$file" &&
 219        if test -z "$notick"
 220        then
 221                test_tick
 222        fi &&
 223        git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
 224        git ${indir:+ -C "$indir"} tag "${4:-$1}"
 225}
 226
 227# Call test_merge with the arguments "<message> <commit>", where <commit>
 228# can be a tag pointing to the commit-to-merge.
 229
 230test_merge () {
 231        test_tick &&
 232        git merge -m "$1" "$2" &&
 233        git tag "$1"
 234}
 235
 236# This function helps systems where core.filemode=false is set.
 237# Use it instead of plain 'chmod +x' to set or unset the executable bit
 238# of a file in the working directory and add it to the index.
 239
 240test_chmod () {
 241        chmod "$@" &&
 242        git update-index --add "--chmod=$@"
 243}
 244
 245# Get the modebits from a file.
 246test_modebits () {
 247        ls -l "$1" | sed -e 's|^\(..........\).*|\1|'
 248}
 249
 250# Unset a configuration variable, but don't fail if it doesn't exist.
 251test_unconfig () {
 252        config_dir=
 253        if test "$1" = -C
 254        then
 255                shift
 256                config_dir=$1
 257                shift
 258        fi
 259        git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
 260        config_status=$?
 261        case "$config_status" in
 262        5) # ok, nothing to unset
 263                config_status=0
 264                ;;
 265        esac
 266        return $config_status
 267}
 268
 269# Set git config, automatically unsetting it after the test is over.
 270test_config () {
 271        config_dir=
 272        if test "$1" = -C
 273        then
 274                shift
 275                config_dir=$1
 276                shift
 277        fi
 278        test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
 279        git ${config_dir:+-C "$config_dir"} config "$@"
 280}
 281
 282test_config_global () {
 283        test_when_finished "test_unconfig --global '$1'" &&
 284        git config --global "$@"
 285}
 286
 287write_script () {
 288        {
 289                echo "#!${2-"$SHELL_PATH"}" &&
 290                cat
 291        } >"$1" &&
 292        chmod +x "$1"
 293}
 294
 295# Use test_set_prereq to tell that a particular prerequisite is available.
 296# The prerequisite can later be checked for in two ways:
 297#
 298# - Explicitly using test_have_prereq.
 299#
 300# - Implicitly by specifying the prerequisite tag in the calls to
 301#   test_expect_{success,failure,code}.
 302#
 303# The single parameter is the prerequisite tag (a simple word, in all
 304# capital letters by convention).
 305
 306test_unset_prereq () {
 307        ! test_have_prereq "$1" ||
 308        satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
 309}
 310
 311test_set_prereq () {
 312        case "$1" in
 313        !*)
 314                test_unset_prereq "${1#!}"
 315                ;;
 316        *)
 317                satisfied_prereq="$satisfied_prereq$1 "
 318                ;;
 319        esac
 320}
 321satisfied_prereq=" "
 322lazily_testable_prereq= lazily_tested_prereq=
 323
 324# Usage: test_lazy_prereq PREREQ 'script'
 325test_lazy_prereq () {
 326        lazily_testable_prereq="$lazily_testable_prereq$1 "
 327        eval test_prereq_lazily_$1=\$2
 328}
 329
 330test_run_lazy_prereq_ () {
 331        script='
 332mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
 333(
 334        cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
 335)'
 336        say >&3 "checking prerequisite: $1"
 337        say >&3 "$script"
 338        test_eval_ "$script"
 339        eval_ret=$?
 340        rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
 341        if test "$eval_ret" = 0; then
 342                say >&3 "prerequisite $1 ok"
 343        else
 344                say >&3 "prerequisite $1 not satisfied"
 345        fi
 346        return $eval_ret
 347}
 348
 349test_have_prereq () {
 350        # prerequisites can be concatenated with ','
 351        save_IFS=$IFS
 352        IFS=,
 353        set -- $*
 354        IFS=$save_IFS
 355
 356        total_prereq=0
 357        ok_prereq=0
 358        missing_prereq=
 359
 360        for prerequisite
 361        do
 362                case "$prerequisite" in
 363                !*)
 364                        negative_prereq=t
 365                        prerequisite=${prerequisite#!}
 366                        ;;
 367                *)
 368                        negative_prereq=
 369                esac
 370
 371                case " $lazily_tested_prereq " in
 372                *" $prerequisite "*)
 373                        ;;
 374                *)
 375                        case " $lazily_testable_prereq " in
 376                        *" $prerequisite "*)
 377                                eval "script=\$test_prereq_lazily_$prerequisite" &&
 378                                if test_run_lazy_prereq_ "$prerequisite" "$script"
 379                                then
 380                                        test_set_prereq $prerequisite
 381                                fi
 382                                lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
 383                        esac
 384                        ;;
 385                esac
 386
 387                total_prereq=$(($total_prereq + 1))
 388                case "$satisfied_prereq" in
 389                *" $prerequisite "*)
 390                        satisfied_this_prereq=t
 391                        ;;
 392                *)
 393                        satisfied_this_prereq=
 394                esac
 395
 396                case "$satisfied_this_prereq,$negative_prereq" in
 397                t,|,t)
 398                        ok_prereq=$(($ok_prereq + 1))
 399                        ;;
 400                *)
 401                        # Keep a list of missing prerequisites; restore
 402                        # the negative marker if necessary.
 403                        prerequisite=${negative_prereq:+!}$prerequisite
 404                        if test -z "$missing_prereq"
 405                        then
 406                                missing_prereq=$prerequisite
 407                        else
 408                                missing_prereq="$prerequisite,$missing_prereq"
 409                        fi
 410                esac
 411        done
 412
 413        test $total_prereq = $ok_prereq
 414}
 415
 416test_declared_prereq () {
 417        case ",$test_prereq," in
 418        *,$1,*)
 419                return 0
 420                ;;
 421        esac
 422        return 1
 423}
 424
 425test_verify_prereq () {
 426        test -z "$test_prereq" ||
 427        expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
 428        BUG "'$test_prereq' does not look like a prereq"
 429}
 430
 431test_expect_failure () {
 432        test_start_
 433        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 434        test "$#" = 2 ||
 435        BUG "not 2 or 3 parameters to test-expect-failure"
 436        test_verify_prereq
 437        export test_prereq
 438        if ! test_skip "$@"
 439        then
 440                say >&3 "checking known breakage: $2"
 441                if test_run_ "$2" expecting_failure
 442                then
 443                        test_known_broken_ok_ "$1"
 444                else
 445                        test_known_broken_failure_ "$1"
 446                fi
 447        fi
 448        test_finish_
 449}
 450
 451test_expect_success () {
 452        test_start_
 453        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 454        test "$#" = 2 ||
 455        BUG "not 2 or 3 parameters to test-expect-success"
 456        test_verify_prereq
 457        export test_prereq
 458        if ! test_skip "$@"
 459        then
 460                say >&3 "expecting success: $2"
 461                if test_run_ "$2"
 462                then
 463                        test_ok_ "$1"
 464                else
 465                        test_failure_ "$@"
 466                fi
 467        fi
 468        test_finish_
 469}
 470
 471# test_external runs external test scripts that provide continuous
 472# test output about their progress, and succeeds/fails on
 473# zero/non-zero exit code.  It outputs the test output on stdout even
 474# in non-verbose mode, and announces the external script with "# run
 475# <n>: ..." before running it.  When providing relative paths, keep in
 476# mind that all scripts run in "trash directory".
 477# Usage: test_external description command arguments...
 478# Example: test_external 'Perl API' perl ../path/to/test.pl
 479test_external () {
 480        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 481        test "$#" = 3 ||
 482        BUG "not 3 or 4 parameters to test_external"
 483        descr="$1"
 484        shift
 485        test_verify_prereq
 486        export test_prereq
 487        if ! test_skip "$descr" "$@"
 488        then
 489                # Announce the script to reduce confusion about the
 490                # test output that follows.
 491                say_color "" "# run $test_count: $descr ($*)"
 492                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 493                # to be able to use them in script
 494                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 495                # Run command; redirect its stderr to &4 as in
 496                # test_run_, but keep its stdout on our stdout even in
 497                # non-verbose mode.
 498                "$@" 2>&4
 499                if test "$?" = 0
 500                then
 501                        if test $test_external_has_tap -eq 0; then
 502                                test_ok_ "$descr"
 503                        else
 504                                say_color "" "# test_external test $descr was ok"
 505                                test_success=$(($test_success + 1))
 506                        fi
 507                else
 508                        if test $test_external_has_tap -eq 0; then
 509                                test_failure_ "$descr" "$@"
 510                        else
 511                                say_color error "# test_external test $descr failed: $@"
 512                                test_failure=$(($test_failure + 1))
 513                        fi
 514                fi
 515        fi
 516}
 517
 518# Like test_external, but in addition tests that the command generated
 519# no output on stderr.
 520test_external_without_stderr () {
 521        # The temporary file has no (and must have no) security
 522        # implications.
 523        tmp=${TMPDIR:-/tmp}
 524        stderr="$tmp/git-external-stderr.$$.tmp"
 525        test_external "$@" 4> "$stderr"
 526        test -f "$stderr" || error "Internal error: $stderr disappeared."
 527        descr="no stderr: $1"
 528        shift
 529        say >&3 "# expecting no stderr from previous command"
 530        if test ! -s "$stderr"
 531        then
 532                rm "$stderr"
 533
 534                if test $test_external_has_tap -eq 0; then
 535                        test_ok_ "$descr"
 536                else
 537                        say_color "" "# test_external_without_stderr test $descr was ok"
 538                        test_success=$(($test_success + 1))
 539                fi
 540        else
 541                if test "$verbose" = t
 542                then
 543                        output=$(echo; echo "# Stderr is:"; cat "$stderr")
 544                else
 545                        output=
 546                fi
 547                # rm first in case test_failure exits.
 548                rm "$stderr"
 549                if test $test_external_has_tap -eq 0; then
 550                        test_failure_ "$descr" "$@" "$output"
 551                else
 552                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 553                        test_failure=$(($test_failure + 1))
 554                fi
 555        fi
 556}
 557
 558# debugging-friendly alternatives to "test [-f|-d|-e]"
 559# The commands test the existence or non-existence of $1. $2 can be
 560# given to provide a more precise diagnosis.
 561test_path_is_file () {
 562        if ! test -f "$1"
 563        then
 564                echo "File $1 doesn't exist. $2"
 565                false
 566        fi
 567}
 568
 569test_path_is_dir () {
 570        if ! test -d "$1"
 571        then
 572                echo "Directory $1 doesn't exist. $2"
 573                false
 574        fi
 575}
 576
 577test_path_exists () {
 578        if ! test -e "$1"
 579        then
 580                echo "Path $1 doesn't exist. $2"
 581                false
 582        fi
 583}
 584
 585# Check if the directory exists and is empty as expected, barf otherwise.
 586test_dir_is_empty () {
 587        test_path_is_dir "$1" &&
 588        if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
 589        then
 590                echo "Directory '$1' is not empty, it contains:"
 591                ls -la "$1"
 592                return 1
 593        fi
 594}
 595
 596# Check if the file exists and has a size greater than zero
 597test_file_not_empty () {
 598        if ! test -s "$1"
 599        then
 600                echo "'$1' is not a non-empty file."
 601                false
 602        fi
 603}
 604
 605test_path_is_missing () {
 606        if test -e "$1"
 607        then
 608                echo "Path exists:"
 609                ls -ld "$1"
 610                if test $# -ge 1
 611                then
 612                        echo "$*"
 613                fi
 614                false
 615        fi
 616}
 617
 618# test_line_count checks that a file has the number of lines it
 619# ought to. For example:
 620#
 621#       test_expect_success 'produce exactly one line of output' '
 622#               do something >output &&
 623#               test_line_count = 1 output
 624#       '
 625#
 626# is like "test $(wc -l <output) = 1" except that it passes the
 627# output through when the number of lines is wrong.
 628
 629test_line_count () {
 630        if test $# != 3
 631        then
 632                BUG "not 3 parameters to test_line_count"
 633        elif ! test $(wc -l <"$3") "$1" "$2"
 634        then
 635                echo "test_line_count: line count for $3 !$1 $2"
 636                cat "$3"
 637                return 1
 638        fi
 639}
 640
 641# Returns success if a comma separated string of keywords ($1) contains a
 642# given keyword ($2).
 643# Examples:
 644# `list_contains "foo,bar" bar` returns 0
 645# `list_contains "foo" bar` returns 1
 646
 647list_contains () {
 648        case ",$1," in
 649        *,$2,*)
 650                return 0
 651                ;;
 652        esac
 653        return 1
 654}
 655
 656# This is not among top-level (test_expect_success | test_expect_failure)
 657# but is a prefix that can be used in the test script, like:
 658#
 659#       test_expect_success 'complain and die' '
 660#           do something &&
 661#           do something else &&
 662#           test_must_fail git checkout ../outerspace
 663#       '
 664#
 665# Writing this as "! git checkout ../outerspace" is wrong, because
 666# the failure could be due to a segv.  We want a controlled failure.
 667#
 668# Accepts the following options:
 669#
 670#   ok=<signal-name>[,<...>]:
 671#     Don't treat an exit caused by the given signal as error.
 672#     Multiple signals can be specified as a comma separated list.
 673#     Currently recognized signal names are: sigpipe, success.
 674#     (Don't use 'success', use 'test_might_fail' instead.)
 675
 676test_must_fail () {
 677        case "$1" in
 678        ok=*)
 679                _test_ok=${1#ok=}
 680                shift
 681                ;;
 682        *)
 683                _test_ok=
 684                ;;
 685        esac
 686        "$@" 2>&7
 687        exit_code=$?
 688        if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
 689        then
 690                echo >&4 "test_must_fail: command succeeded: $*"
 691                return 1
 692        elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
 693        then
 694                return 0
 695        elif test $exit_code -gt 129 && test $exit_code -le 192
 696        then
 697                echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
 698                return 1
 699        elif test $exit_code -eq 127
 700        then
 701                echo >&4 "test_must_fail: command not found: $*"
 702                return 1
 703        elif test $exit_code -eq 126
 704        then
 705                echo >&4 "test_must_fail: valgrind error: $*"
 706                return 1
 707        fi
 708        return 0
 709} 7>&2 2>&4
 710
 711# Similar to test_must_fail, but tolerates success, too.  This is
 712# meant to be used in contexts like:
 713#
 714#       test_expect_success 'some command works without configuration' '
 715#               test_might_fail git config --unset all.configuration &&
 716#               do something
 717#       '
 718#
 719# Writing "git config --unset all.configuration || :" would be wrong,
 720# because we want to notice if it fails due to segv.
 721#
 722# Accepts the same options as test_must_fail.
 723
 724test_might_fail () {
 725        test_must_fail ok=success "$@" 2>&7
 726} 7>&2 2>&4
 727
 728# Similar to test_must_fail and test_might_fail, but check that a
 729# given command exited with a given exit code. Meant to be used as:
 730#
 731#       test_expect_success 'Merge with d/f conflicts' '
 732#               test_expect_code 1 git merge "merge msg" B master
 733#       '
 734
 735test_expect_code () {
 736        want_code=$1
 737        shift
 738        "$@" 2>&7
 739        exit_code=$?
 740        if test $exit_code = $want_code
 741        then
 742                return 0
 743        fi
 744
 745        echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 746        return 1
 747} 7>&2 2>&4
 748
 749# test_cmp is a helper function to compare actual and expected output.
 750# You can use it like:
 751#
 752#       test_expect_success 'foo works' '
 753#               echo expected >expected &&
 754#               foo >actual &&
 755#               test_cmp expected actual
 756#       '
 757#
 758# This could be written as either "cmp" or "diff -u", but:
 759# - cmp's output is not nearly as easy to read as diff -u
 760# - not all diff versions understand "-u"
 761
 762test_cmp() {
 763        $GIT_TEST_CMP "$@"
 764}
 765
 766# Check that the given config key has the expected value.
 767#
 768#    test_cmp_config [-C <dir>] <expected-value>
 769#                    [<git-config-options>...] <config-key>
 770#
 771# for example to check that the value of core.bar is foo
 772#
 773#    test_cmp_config foo core.bar
 774#
 775test_cmp_config() {
 776        local GD &&
 777        if test "$1" = "-C"
 778        then
 779                shift &&
 780                GD="-C $1" &&
 781                shift
 782        fi &&
 783        printf "%s\n" "$1" >expect.config &&
 784        shift &&
 785        git $GD config "$@" >actual.config &&
 786        test_cmp expect.config actual.config
 787}
 788
 789# test_cmp_bin - helper to compare binary files
 790
 791test_cmp_bin() {
 792        cmp "$@"
 793}
 794
 795# Use this instead of test_cmp to compare files that contain expected and
 796# actual output from git commands that can be translated.  When running
 797# under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
 798# results.
 799test_i18ncmp () {
 800        ! test_have_prereq C_LOCALE_OUTPUT || test_cmp "$@"
 801}
 802
 803# Use this instead of "grep expected-string actual" to see if the
 804# output from a git command that can be translated either contains an
 805# expected string, or does not contain an unwanted one.  When running
 806# under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
 807# results.
 808test_i18ngrep () {
 809        eval "last_arg=\${$#}"
 810
 811        test -f "$last_arg" ||
 812        BUG "test_i18ngrep requires a file to read as the last parameter"
 813
 814        if test $# -lt 2 ||
 815           { test "x!" = "x$1" && test $# -lt 3 ; }
 816        then
 817                BUG "too few parameters to test_i18ngrep"
 818        fi
 819
 820        if test_have_prereq !C_LOCALE_OUTPUT
 821        then
 822                # pretend success
 823                return 0
 824        fi
 825
 826        if test "x!" = "x$1"
 827        then
 828                shift
 829                ! grep "$@" && return 0
 830
 831                echo >&4 "error: '! grep $@' did find a match in:"
 832        else
 833                grep "$@" && return 0
 834
 835                echo >&4 "error: 'grep $@' didn't find a match in:"
 836        fi
 837
 838        if test -s "$last_arg"
 839        then
 840                cat >&4 "$last_arg"
 841        else
 842                echo >&4 "<File '$last_arg' is empty>"
 843        fi
 844
 845        return 1
 846}
 847
 848# Call any command "$@" but be more verbose about its
 849# failure. This is handy for commands like "test" which do
 850# not output anything when they fail.
 851verbose () {
 852        "$@" && return 0
 853        echo >&4 "command failed: $(git rev-parse --sq-quote "$@")"
 854        return 1
 855}
 856
 857# Check if the file expected to be empty is indeed empty, and barfs
 858# otherwise.
 859
 860test_must_be_empty () {
 861        test_path_is_file "$1" &&
 862        if test -s "$1"
 863        then
 864                echo "'$1' is not empty, it contains:"
 865                cat "$1"
 866                return 1
 867        fi
 868}
 869
 870# Tests that its two parameters refer to the same revision
 871test_cmp_rev () {
 872        if test $# != 2
 873        then
 874                error "bug in the test script: test_cmp_rev requires two revisions, but got $#"
 875        else
 876                local r1 r2
 877                r1=$(git rev-parse --verify "$1") &&
 878                r2=$(git rev-parse --verify "$2") &&
 879                if test "$r1" != "$r2"
 880                then
 881                        cat >&4 <<-EOF
 882                        error: two revisions point to different objects:
 883                          '$1': $r1
 884                          '$2': $r2
 885                        EOF
 886                        return 1
 887                fi
 888        fi
 889}
 890
 891# Print a sequence of integers in increasing order, either with
 892# two arguments (start and end):
 893#
 894#     test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
 895#
 896# or with one argument (end), in which case it starts counting
 897# from 1.
 898
 899test_seq () {
 900        case $# in
 901        1)      set 1 "$@" ;;
 902        2)      ;;
 903        *)      BUG "not 1 or 2 parameters to test_seq" ;;
 904        esac
 905        test_seq_counter__=$1
 906        while test "$test_seq_counter__" -le "$2"
 907        do
 908                echo "$test_seq_counter__"
 909                test_seq_counter__=$(( $test_seq_counter__ + 1 ))
 910        done
 911}
 912
 913# This function can be used to schedule some commands to be run
 914# unconditionally at the end of the test to restore sanity:
 915#
 916#       test_expect_success 'test core.capslock' '
 917#               git config core.capslock true &&
 918#               test_when_finished "git config --unset core.capslock" &&
 919#               hello world
 920#       '
 921#
 922# That would be roughly equivalent to
 923#
 924#       test_expect_success 'test core.capslock' '
 925#               git config core.capslock true &&
 926#               hello world
 927#               git config --unset core.capslock
 928#       '
 929#
 930# except that the greeting and config --unset must both succeed for
 931# the test to pass.
 932#
 933# Note that under --immediate mode, no clean-up is done to help diagnose
 934# what went wrong.
 935
 936test_when_finished () {
 937        # We cannot detect when we are in a subshell in general, but by
 938        # doing so on Bash is better than nothing (the test will
 939        # silently pass on other shells).
 940        test "${BASH_SUBSHELL-0}" = 0 ||
 941        BUG "test_when_finished does nothing in a subshell"
 942        test_cleanup="{ $*
 943                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 944}
 945
 946# This function can be used to schedule some commands to be run
 947# unconditionally at the end of the test script, e.g. to stop a daemon:
 948#
 949#       test_expect_success 'test git daemon' '
 950#               git daemon &
 951#               daemon_pid=$! &&
 952#               test_atexit 'kill $daemon_pid' &&
 953#               hello world
 954#       '
 955#
 956# The commands will be executed before the trash directory is removed,
 957# i.e. the atexit commands will still be able to access any pidfiles or
 958# socket files.
 959#
 960# Note that these commands will be run even when a test script run
 961# with '--immediate' fails.  Be careful with your atexit commands to
 962# minimize any changes to the failed state.
 963
 964test_atexit () {
 965        # We cannot detect when we are in a subshell in general, but by
 966        # doing so on Bash is better than nothing (the test will
 967        # silently pass on other shells).
 968        test "${BASH_SUBSHELL-0}" = 0 ||
 969        error "bug in test script: test_atexit does nothing in a subshell"
 970        test_atexit_cleanup="{ $*
 971                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_atexit_cleanup"
 972}
 973
 974# Most tests can use the created repository, but some may need to create more.
 975# Usage: test_create_repo <directory>
 976test_create_repo () {
 977        test "$#" = 1 ||
 978        BUG "not 1 parameter to test-create-repo"
 979        repo="$1"
 980        mkdir -p "$repo"
 981        (
 982                cd "$repo" || error "Cannot setup test environment"
 983                "${GIT_TEST_INSTALLED:-$GIT_EXEC_PATH}/git$X" init \
 984                        "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 985                error "cannot run git init -- have you built things yet?"
 986                mv .git/hooks .git/hooks-disabled
 987        ) || exit
 988}
 989
 990# This function helps on symlink challenged file systems when it is not
 991# important that the file system entry is a symbolic link.
 992# Use test_ln_s_add instead of "ln -s x y && git add y" to add a
 993# symbolic link entry y to the index.
 994
 995test_ln_s_add () {
 996        if test_have_prereq SYMLINKS
 997        then
 998                ln -s "$1" "$2" &&
 999                git update-index --add "$2"
1000        else
1001                printf '%s' "$1" >"$2" &&
1002                ln_s_obj=$(git hash-object -w "$2") &&
1003                git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
1004                # pick up stat info from the file
1005                git update-index "$2"
1006        fi
1007}
1008
1009# This function writes out its parameters, one per line
1010test_write_lines () {
1011        printf "%s\n" "$@"
1012}
1013
1014perl () {
1015        command "$PERL_PATH" "$@" 2>&7
1016} 7>&2 2>&4
1017
1018# Is the value one of the various ways to spell a boolean true/false?
1019test_normalize_bool () {
1020        git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
1021}
1022
1023# Given a variable $1, normalize the value of it to one of "true",
1024# "false", or "auto" and store the result to it.
1025#
1026#     test_tristate GIT_TEST_HTTPD
1027#
1028# A variable set to an empty string is set to 'false'.
1029# A variable set to 'false' or 'auto' keeps its value.
1030# Anything else is set to 'true'.
1031# An unset variable defaults to 'auto'.
1032#
1033# The last rule is to allow people to set the variable to an empty
1034# string and export it to decline testing the particular feature
1035# for versions both before and after this change.  We used to treat
1036# both unset and empty variable as a signal for "do not test" and
1037# took any non-empty string as "please test".
1038
1039test_tristate () {
1040        if eval "test x\"\${$1+isset}\" = xisset"
1041        then
1042                # explicitly set
1043                eval "
1044                        case \"\$$1\" in
1045                        '')     $1=false ;;
1046                        auto)   ;;
1047                        *)      $1=\$(test_normalize_bool \$$1 || echo true) ;;
1048                        esac
1049                "
1050        else
1051                eval "$1=auto"
1052        fi
1053}
1054
1055# Exit the test suite, either by skipping all remaining tests or by
1056# exiting with an error. If "$1" is "auto", we then we assume we were
1057# opportunistically trying to set up some tests and we skip. If it is
1058# "true", then we report a failure.
1059#
1060# The error/skip message should be given by $2.
1061#
1062test_skip_or_die () {
1063        case "$1" in
1064        auto)
1065                skip_all=$2
1066                test_done
1067                ;;
1068        true)
1069                error "$2"
1070                ;;
1071        *)
1072                error "BUG: test tristate is '$1' (real error: $2)"
1073        esac
1074}
1075
1076# The following mingw_* functions obey POSIX shell syntax, but are actually
1077# bash scripts, and are meant to be used only with bash on Windows.
1078
1079# A test_cmp function that treats LF and CRLF equal and avoids to fork
1080# diff when possible.
1081mingw_test_cmp () {
1082        # Read text into shell variables and compare them. If the results
1083        # are different, use regular diff to report the difference.
1084        local test_cmp_a= test_cmp_b=
1085
1086        # When text came from stdin (one argument is '-') we must feed it
1087        # to diff.
1088        local stdin_for_diff=
1089
1090        # Since it is difficult to detect the difference between an
1091        # empty input file and a failure to read the files, we go straight
1092        # to diff if one of the inputs is empty.
1093        if test -s "$1" && test -s "$2"
1094        then
1095                # regular case: both files non-empty
1096                mingw_read_file_strip_cr_ test_cmp_a <"$1"
1097                mingw_read_file_strip_cr_ test_cmp_b <"$2"
1098        elif test -s "$1" && test "$2" = -
1099        then
1100                # read 2nd file from stdin
1101                mingw_read_file_strip_cr_ test_cmp_a <"$1"
1102                mingw_read_file_strip_cr_ test_cmp_b
1103                stdin_for_diff='<<<"$test_cmp_b"'
1104        elif test "$1" = - && test -s "$2"
1105        then
1106                # read 1st file from stdin
1107                mingw_read_file_strip_cr_ test_cmp_a
1108                mingw_read_file_strip_cr_ test_cmp_b <"$2"
1109                stdin_for_diff='<<<"$test_cmp_a"'
1110        fi
1111        test -n "$test_cmp_a" &&
1112        test -n "$test_cmp_b" &&
1113        test "$test_cmp_a" = "$test_cmp_b" ||
1114        eval "diff -u \"\$@\" $stdin_for_diff"
1115}
1116
1117# $1 is the name of the shell variable to fill in
1118mingw_read_file_strip_cr_ () {
1119        # Read line-wise using LF as the line separator
1120        # and use IFS to strip CR.
1121        local line
1122        while :
1123        do
1124                if IFS=$'\r' read -r -d $'\n' line
1125                then
1126                        # good
1127                        line=$line$'\n'
1128                else
1129                        # we get here at EOF, but also if the last line
1130                        # was not terminated by LF; in the latter case,
1131                        # some text was read
1132                        if test -z "$line"
1133                        then
1134                                # EOF, really
1135                                break
1136                        fi
1137                fi
1138                eval "$1=\$$1\$line"
1139        done
1140}
1141
1142# Like "env FOO=BAR some-program", but run inside a subshell, which means
1143# it also works for shell functions (though those functions cannot impact
1144# the environment outside of the test_env invocation).
1145test_env () {
1146        (
1147                while test $# -gt 0
1148                do
1149                        case "$1" in
1150                        *=*)
1151                                eval "${1%%=*}=\${1#*=}"
1152                                eval "export ${1%%=*}"
1153                                shift
1154                                ;;
1155                        *)
1156                                "$@" 2>&7
1157                                exit
1158                                ;;
1159                        esac
1160                done
1161        )
1162} 7>&2 2>&4
1163
1164# Returns true if the numeric exit code in "$2" represents the expected signal
1165# in "$1". Signals should be given numerically.
1166test_match_signal () {
1167        if test "$2" = "$((128 + $1))"
1168        then
1169                # POSIX
1170                return 0
1171        elif test "$2" = "$((256 + $1))"
1172        then
1173                # ksh
1174                return 0
1175        fi
1176        return 1
1177}
1178
1179# Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1180test_copy_bytes () {
1181        perl -e '
1182                my $len = $ARGV[1];
1183                while ($len > 0) {
1184                        my $s;
1185                        my $nread = sysread(STDIN, $s, $len);
1186                        die "cannot read: $!" unless defined($nread);
1187                        last unless $nread;
1188                        print $s;
1189                        $len -= $nread;
1190                }
1191        ' - "$1"
1192}
1193
1194# run "$@" inside a non-git directory
1195nongit () {
1196        test -d non-repo ||
1197        mkdir non-repo ||
1198        return 1
1199
1200        (
1201                GIT_CEILING_DIRECTORIES=$(pwd) &&
1202                export GIT_CEILING_DIRECTORIES &&
1203                cd non-repo &&
1204                "$@" 2>&7
1205        )
1206} 7>&2 2>&4
1207
1208# convert stdin to pktline representation; note that empty input becomes an
1209# empty packet, not a flush packet (for that you can just print 0000 yourself).
1210packetize() {
1211        cat >packetize.tmp &&
1212        len=$(wc -c <packetize.tmp) &&
1213        printf '%04x%s' "$(($len + 4))" &&
1214        cat packetize.tmp &&
1215        rm -f packetize.tmp
1216}
1217
1218# Parse the input as a series of pktlines, writing the result to stdout.
1219# Sideband markers are removed automatically, and the output is routed to
1220# stderr if appropriate.
1221#
1222# NUL bytes are converted to "\\0" for ease of parsing with text tools.
1223depacketize () {
1224        perl -e '
1225                while (read(STDIN, $len, 4) == 4) {
1226                        if ($len eq "0000") {
1227                                print "FLUSH\n";
1228                        } else {
1229                                read(STDIN, $buf, hex($len) - 4);
1230                                $buf =~ s/\0/\\0/g;
1231                                if ($buf =~ s/^[\x2\x3]//) {
1232                                        print STDERR $buf;
1233                                } else {
1234                                        $buf =~ s/^\x1//;
1235                                        print $buf;
1236                                }
1237                        }
1238                }
1239        '
1240}
1241
1242# Converts base-16 data into base-8. The output is given as a sequence of
1243# escaped octals, suitable for consumption by 'printf'.
1244hex2oct () {
1245        perl -ne 'printf "\\%03o", hex for /../g'
1246}
1247
1248# Set the hash algorithm in use to $1.  Only useful when testing the testsuite.
1249test_set_hash () {
1250        test_hash_algo="$1"
1251}
1252
1253# Detect the hash algorithm in use.
1254test_detect_hash () {
1255        # Currently we only support SHA-1, but in the future this function will
1256        # actually detect the algorithm in use.
1257        test_hash_algo='sha1'
1258}
1259
1260# Load common hash metadata and common placeholder object IDs for use with
1261# test_oid.
1262test_oid_init () {
1263        test -n "$test_hash_algo" || test_detect_hash &&
1264        test_oid_cache <"$TEST_DIRECTORY/oid-info/hash-info" &&
1265        test_oid_cache <"$TEST_DIRECTORY/oid-info/oid"
1266}
1267
1268# Load key-value pairs from stdin suitable for use with test_oid.  Blank lines
1269# and lines starting with "#" are ignored.  Keys must be shell identifier
1270# characters.
1271#
1272# Examples:
1273# rawsz sha1:20
1274# rawsz sha256:32
1275test_oid_cache () {
1276        local tag rest k v &&
1277
1278        { test -n "$test_hash_algo" || test_detect_hash; } &&
1279        while read tag rest
1280        do
1281                case $tag in
1282                \#*)
1283                        continue;;
1284                ?*)
1285                        # non-empty
1286                        ;;
1287                *)
1288                        # blank line
1289                        continue;;
1290                esac &&
1291
1292                k="${rest%:*}" &&
1293                v="${rest#*:}" &&
1294
1295                if ! expr "$k" : '[a-z0-9][a-z0-9]*$' >/dev/null
1296                then
1297                        BUG 'bad hash algorithm'
1298                fi &&
1299                eval "test_oid_${k}_$tag=\"\$v\""
1300        done
1301}
1302
1303# Look up a per-hash value based on a key ($1).  The value must have been loaded
1304# by test_oid_init or test_oid_cache.
1305test_oid () {
1306        local var="test_oid_${test_hash_algo}_$1" &&
1307
1308        # If the variable is unset, we must be missing an entry for this
1309        # key-hash pair, so exit with an error.
1310        if eval "test -z \"\${$var+set}\""
1311        then
1312                BUG "undefined key '$1'"
1313        fi &&
1314        eval "printf '%s' \"\${$var}\""
1315}
1316
1317# Choose a port number based on the test script's number and store it in
1318# the given variable name, unless that variable already contains a number.
1319test_set_port () {
1320        local var=$1 port
1321
1322        if test $# -ne 1 || test -z "$var"
1323        then
1324                BUG "test_set_port requires a variable name"
1325        fi
1326
1327        eval port=\$$var
1328        case "$port" in
1329        "")
1330                # No port is set in the given env var, use the test
1331                # number as port number instead.
1332                # Remove not only the leading 't', but all leading zeros
1333                # as well, so the arithmetic below won't (mis)interpret
1334                # a test number like '0123' as an octal value.
1335                port=${this_test#${this_test%%[1-9]*}}
1336                if test "${port:-0}" -lt 1024
1337                then
1338                        # root-only port, use a larger one instead.
1339                        port=$(($port + 10000))
1340                fi
1341                ;;
1342        *[!0-9]*|0*)
1343                error >&7 "invalid port number: $port"
1344                ;;
1345        *)
1346                # The user has specified the port.
1347                ;;
1348        esac
1349
1350        # Make sure that parallel '--stress' test jobs get different
1351        # ports.
1352        port=$(($port + ${GIT_TEST_STRESS_JOB_NR:-0}))
1353        eval $var=$port
1354}